#if __has_include(<React/RCTConvert.h>)
#import <React/RCTConvert.h>
#import <React/RCTBridge.h>
#import <React/RCTEventDispatcher.h>
#import <React/RCTUtils.h>
#else
#import "RCTConvert.h"
#import "RCTBridge.h"
#import "RCTEventDispatcher.h"
#import "RCTUtils.h"
#endif
#import "RNPushbotsReact.h"
#if __IPHONE_OS_VERSION_MIN_REQUIRED < __IPHONE_8_0

#define UIUserNotificationTypeAlert UIRemoteNotificationTypeAlert
#define UIUserNotificationTypeBadge UIRemoteNotificationTypeBadge
#define UIUserNotificationTypeSound UIRemoteNotificationTypeSound
#define UIUserNotificationTypeNone  UIRemoteNotificationTypeNone
#define UIUserNotificationType      UIRemoteNotificationType

#endif
@interface RNPushbotsReact ()
@end

@implementation RNPushbotsReact
RCT_EXPORT_MODULE(RNPushbotsReact*)
// OSNotificationOpenedResult* coldStartOSNotificationOpenedResult;
// - (void)setBridge:(RCTBridge *)receivedBridge {
//     _bridge = receivedBridge;
//     curRCTBridge = receivedBridge;

//     if (coldStartOSNotificationOpenedResult) {
//         [self handleRemoteNotificationOpened:[coldStartOSNotificationOpenedResult stringify]];
//         coldStartOSNotificationOpenedResult = nil;
//     }
// }
- (id)initWithAppId:(NSString*)appId{

	self.pushbotsClient = [[Pushbots alloc] initWithAppId:appId prompt:YES];

//handleNotificationReceived:^(OSNotification* notification) {
//              [self handleRemoteNotificationReceived:[notification stringify]];
//          }
    return self;
}




- (void)handleRemoteNotificationReceived:(NSString *)notification {

    NSError *jsonError;
    NSData *objectData = [notification dataUsingEncoding:NSUTF8StringEncoding];
    NSDictionary *json = [NSJSONSerialization JSONObjectWithData:objectData
                                                         options:NSJSONReadingMutableContainers
                                                           error:&jsonError];



    [curRCTBridge.eventDispatcher sendAppEventWithName:@"Pushbots-remoteNotificationReceived" body:json];
}


- (void)handleRemoteNotificationOpened:(NSString *)result {

    NSError *jsonError;
    NSData *objectData = [result dataUsingEncoding:NSUTF8StringEncoding];
    NSDictionary *json = [NSJSONSerialization JSONObjectWithData:objectData
                                                         options:NSJSONReadingMutableContainers
                                                           error:&jsonError];

    [curRCTBridge.eventDispatcher sendAppEventWithName:@"Pushbots-remoteNotificationOpened" body:json];
}

- (void)handleRemoteNotificationsRegistered:(NSNotification *)notification {
    [self.bridge.eventDispatcher sendAppEventWithName:@"Pushbots-remoteNotificationsRegistered" body:notification.userInfo];
}

RCT_EXPORT_METHOD(registerForRemoteNotifications) {
    [self.pushbotsClient registerForRemoteNotifications];
    
}



RCT_EXPORT_METHOD(checkPermissions:(RCTResponseSenderBlock)callback)
{
    if (RCTRunningInAppExtension()) {
        callback(@[@{@"alert": @NO, @"badge": @NO, @"sound": @NO}]);
        return;
    }

    NSUInteger types = 0;
    if ([UIApplication instancesRespondToSelector:@selector(currentUserNotificationSettings)]) {
        types = [RCTSharedApplication() currentUserNotificationSettings].types;
    } else {

#if __IPHONE_OS_VERSION_MIN_REQUIRED < __IPHONE_8_0
        types = [RCTSharedApplication() enabledRemoteNotificationTypes];
#endif

    }

    callback(@[@{
                   @"alert": @((types & UIUserNotificationTypeAlert) > 0),
                   @"badge": @((types & UIUserNotificationTypeBadge) > 0),
                   @"sound": @((types & UIUserNotificationTypeSound) > 0),
                   }]);
}

RCT_EXPORT_METHOD(requestPermissions:(NSDictionary *)permissions) {
    if (RCTRunningInAppExtension()) {
        return;
    }

    UIUserNotificationType types = UIUserNotificationTypeNone;
    if (permissions) {
        if ([RCTConvert BOOL:permissions[@"alert"]]) {
            types |= UIUserNotificationTypeAlert;
        }
        if ([RCTConvert BOOL:permissions[@"badge"]]) {
            types |= UIUserNotificationTypeBadge;
        }
        if ([RCTConvert BOOL:permissions[@"sound"]]) {
            types |= UIUserNotificationTypeSound;
        }
    } else {
        types = UIUserNotificationTypeAlert | UIUserNotificationTypeBadge | UIUserNotificationTypeSound;
    }

    UIApplication *app = RCTSharedApplication();
    if ([app respondsToSelector:@selector(registerUserNotificationSettings:)]) {
        UIUserNotificationSettings *notificationSettings =
        [UIUserNotificationSettings settingsForTypes:(NSUInteger)types categories:nil];
        [app registerUserNotificationSettings:notificationSettings];
        [app registerForRemoteNotifications];
    } else {
        [app registerForRemoteNotificationTypes:(NSUInteger)types];
    }
}

RCT_EXPORT_METHOD(registerOnPushbots) {
[self.PushbotsClient registerOnPushbots:deviceToken];

}


- (dispatch_queue_t)methodQueue
{
    return dispatch_get_main_queue();
}


@end

